package net.thecodersbreakfast.corejdk.serialization.surrogate;


import java.io.ObjectStreamException;
import java.io.Serializable;

/**
 * @author olivier
 */
public class PojoSurrogate implements Serializable, Surrogate<Pojo> {

    private final String foo;

    public PojoSurrogate(Pojo pojo) {
        this.foo = pojo.getMsg();
    }

    private Object readResolve() throws ObjectStreamException {
        return new Pojo(foo);
    }

    public static class Factory implements SurrogateFactory<Pojo> {
        @Override
        public Class<Pojo> getTargetClass() {
            return Pojo.class;
        }

        @Override
        public PojoSurrogate newSurrogate(Pojo target) {
            return new PojoSurrogate(target);
        }
    }
}
