package net.thecodersbreakfast.corejdk.serialization.surrogate;

import java.util.HashMap;
import java.util.Map;

/**
 * @author olivier
 */
public class SurrogateFactoryRegistry {

    private final Map<Class<?>, SurrogateFactory<?>> surrogates = new HashMap<Class<?>, SurrogateFactory<?>>();

    public void registerSurrogateFactory(SurrogateFactory<?> surrogate) {
        surrogates.put(surrogate.getTargetClass(), surrogate);
    }

    @SuppressWarnings("unchecked")
    public <T> SurrogateFactory<T> getSurrogateFactory(Class<T> targetClass) {
        return (SurrogateFactory<T>) surrogates.get(targetClass);
    }

}
