package net.thecodersbreakfast.corejdk.serialization.surrogate;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

/**
 * @author olivier
 */
public class SurrogateObjectOutputStream extends ObjectOutputStream {

    private final SurrogateFactoryRegistry registry;

    public SurrogateObjectOutputStream(OutputStream out, SurrogateFactoryRegistry registry) throws IOException {
        super(out);
        this.registry = registry;
        enableReplaceObject(true);
    }

    protected SurrogateObjectOutputStream(SurrogateFactoryRegistry registry) throws IOException, SecurityException {
        super();
        this.registry = registry;
        enableReplaceObject(true);
    }

    @Override
    @SuppressWarnings("unchecked")
    protected Object replaceObject(Object obj) throws IOException {
        SurrogateFactory surrogateFactory = registry.getSurrogateFactory(obj.getClass());
        if (surrogateFactory != null) {
            return surrogateFactory.newSurrogate(obj);
        } else return super.replaceObject(obj);
    }

}
